/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
/* The source code in this module is proprietary software belonging to       */
/* Clark Development Company and is part of the PCBoard source code library. */
/* You are granted the right to use this source code for the building of any */
/* of the PCBoard products you have licensed.  Any other usage is forbidden  */
/* without prior written consent from Clark Development Company, Inc.        */
/*                                                                           */
/* Be sure to read the source code license agreement before utilizing any    */
/* of the source code found herein.                                          */
/*                                                                           */
/* Copyright (C) 1996  Clark Development Company, Inc.  All Rights Reserved. */
/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/


/*  NOTE:  This module MUST be compiled with "merge duplicate strings"   */
/*         turned off otherwise it will not generate a good PCBTEXT file */

#include "pcbtext.h"

/* NOTE: Some records are written to the caller log ..  a maximum length of */
/* 56 will allow the entire record to be written to the log (counting the   */
/* 6 spaces for indent), any more than that will be truncated in the log    */


pcbtexttype Array[TEXT_ARRAY] = {

/* 0 */    {153, 'L', 77, PCB_ANSIRED    , "PCBoard version 14.5 & 15.0 & 15.2 & 15.3 PCBTEXT file"},
/* 1 */    {145, 'L', 60, PCB_ANSIWHITE  , "Leave a comment for the sysop (Enter)=no"},
/* 2 */    {145, 'R', 27, PCB_ANSIYELLOW , " Brand of CPU you are using"},
/* 3 */    {145, 'L', 56, PCB_ANSIRED    , "Access Denied - Upcoming Event Pending ..."},
/* 4 */    {145, 'L', 56, PCB_ANSIRED    , "Time Limit Exceeded."},
/* 5 */    {145, 'L', 56, PCB_ANSIRED    , "Access Denied - Unauthorized name match on @USER@!"},
/* 6 */    {145, 'L', 56, PCB_ANSIRED    , "Access Denied - You are Locked Out of this System!"},
/* 7 */    {145, 'L', 56, PCB_ANSIRED    , "Access Denied - Excessive Password Failures!"},
/* 8 */    {145, 'L', 56, PCB_ANSIRED    , "Access Denied - Refused to Complete Registration!"},
/* 9 */    {145, 'L', 56, PCB_ANSIRED    , "Access Denied - Remote DOS Password Failure!"},
/* 10 */   {145, 'L', 56, PCB_ANSIRED    , "Access Denied - @USER@ is in use on another Node!"},
/* 11 */   {145, 'L', 56, PCB_ANSIRED    , "Sorry, @FIRST@, this is a `Closed' Board ..."},
/* 12 */   {145, 'L', 56, PCB_ANSIRED    , "Security Violation(s) - Disconnecting ..."},
/* 13 */   {145, 'L', 56, PCB_ANSIRED    , "There is presently no room for your text, @FIRST@ ..."},
/* 14 */   {145, 'L', 56, PCB_ANSIRED    , "A message to `ALL' cannot be protected, @FIRST@ ..."},
/* 15 */   {145, 'L', 77, PCB_ANSIRED    , "Callers must know p/w to read message!  Continue (Enter)=no"},
/* 16 */   {145, 'L', 50, PCB_ANSIRED    , "Protocol Unavailable - Modem Type Wrong!"},
/* 17 */   {150, 'L', 56, PCB_ANSICYAN   , "Local Download Path"},
/* 18 */   {145, 'L', 56, PCB_ANSIWHITE  , "Password to Read Message (ENTER alone aborts)"},
/* 19 */   {150, 'L', 56, PCB_ANSICYAN   , "Local Upload Path or Filename"},
/* 20 */   {145, 'L', 56, PCB_ANSIRED    , "Printer Off-Line ..."},
/* 21 */   {145, 'R', 35, PCB_ANSIYELLOW , "Enter the Security password desired"},
/* 22 */   {145, 'L', 56, PCB_ANSIGREEN  , "Reply to Msgs: (#), (#), (Enter)=abort"},
/* 23 */   {145, 'L', 56, PCB_ANSIRED    , "Path error in system configuration!"},
/* 24 */   {145, 'L', 56, PCB_ANSIRED    , "Selection not available in local mode."},
/* 25 */   {145, 'L', 56, PCB_ANSIRED    , "Temporary Sysop privileges removed ..."},
/* 26 */   {145, 'L', 56, PCB_ANSIRED    , "Temporary Sysop privileges granted this call only!"},
/* 27 */   {145, 'L', 56, PCB_NOCHANGE   , "Graphics mode is not available, @FIRST@ ..."},
/* 28 */   {145, 'L', 56, PCB_ANSIRED    , "Automatic Lockout completed ..."},
/* 29 */   {150, 'L', 77, PCB_ANSIRED    , "!|*|Y01000400|c0A|@0005RIPscrip |Y01000200|c0B|@3W0Fmode on|g0006"},
/* 30 */   {145, 'L', 56, PCB_ANSIRED    , "Text Entry is Full ..."},
/* 31 */   {145, 'L', 56, PCB_ANSIRED    , "ASCII transfer is not available on a binary file!"},
/* 32 */   {145, 'L', 77, PCB_ANSIRED    , "NOTE: Transfer must end with a (Ctrl-Z)!"},
/* 33 */   {145, 'L', 6,  PCB_NOCHANGE   , "None"},
/* 34 */   {150, 'L', 50, PCB_NOCHANGE   , "NO CONNECT / @OPTEXT@"},
/* 35 */   {150, 'L', 20, PCB_NOCHANGE   , "FULL COUNTDOWN"},
/* 36 */   {150, 'L', 20, PCB_NOCHANGE   , "NO CARRIER"},
/* 37 */   {145, 'L', 56, PCB_ANSIRED    , "Disk Full - System presently unavailable!"},
/* 38 */   {150, 'L', 72, PCB_NOCHANGE   , "ALL NODES ARE BUSY AT THIS TIME PLEASE TRY LATER"},
/* 39 */   {150, 'L', 25, PCB_NOCHANGE   , "ALL"},
/* 40 */   {150, 'L', 72, PCB_ANSIWHITE  , "Uploading text file directly into the message editor..."},
/* 41 */   {150, 'L', 20, PCB_NOCHANGE   , "~(Echo)"},
/* 42 */   {150, 'L', 20, PCB_NOCHANGE   , "~(A)"},
/* 43 */   {150, 'L', 20, PCB_NOCHANGE   , "~(R/O)"},
/* 44 */   {145, 'L', 56, PCB_ANSIRED    , "Error reading Script Questionnaire"},
/* 45 */   {145, 'L', 56, PCB_ANSIRED    , "Error reading Message base in use!"},
/* 46 */   {145, 'L', 70, PCB_ANSIRED    , "Unable to exit to DOS - no REMOTE.SYS file found!"},
/* 47 */   {145, 'L', 56, PCB_ANSIRED    , "No record available to update!"},
/* 48 */   {145, 'L', 56, PCB_ANSICYAN   , "Messages Successfully Packed & Purified!"},
/* 49 */   {150, 'L', 56, PCB_ANSIRED    , "Enter `handle' to be used for Node Chat"},
/* 50 */   {150, 'L', 62, PCB_ANSIRED    , "File Attachment: @OPTEXT@"},
/* 51 */   {145, 'L', 56, PCB_ANSIRED    , "Enter a longer description of the file please!"},
/* 52 */   {145, 'L', 56, PCB_ANSIRED    , "No Script Questionnaires are available, @FIRST@ ..."},
/* 53 */   {145, 'L', 70, PCB_ANSIYELLOW , "(R) to re-enter your name or (C) to continue logon as a new user"},
/* 54 */   {145, 'L', 70, PCB_ANSIGREEN  , "Would you like to register with us, @FIRST@? (Enter)=yes"},
/* 55 */   {145, 'L', 56, PCB_ANSIRED    , "Keyboard Time Expired!"},
/* 56 */   {145, 'L', 56, PCB_ANSIRED    , "Invalid Entry!  Please try again, @FIRST@ ..."},
/* 57 */   {145, 'L', 56, PCB_ANSIRED    , "Sorry, @FIRST@, uploads are Private ..."},
/* 58 */   {145, 'L', 77, PCB_ANSIGREEN  , "Online Registration being performed - please wait, @FIRST@ ..."},
/* 59 */   {145, 'L', 56, PCB_ANSIRED    , "Automatic Disconnect Completed!"},
/* 60 */   {145, 'R', 35, PCB_ANSIYELLOW , "Full USER Name to Find (Enter)=none"},
/* 61 */   {145, 'L', 70, PCB_ANSIYELLOW , "Enter the filename to Download (Enter)=none"},
/* 62 */   {145, 'L', 70, PCB_ANSIYELLOW , "Enter the filename to View (Enter)=none"},
/* 63 */   {145, 'L', 70, PCB_ANSIYELLOW , "Menu Letter/Command you need Help with (Enter)=none"},
/* 64 */   {145, 'L', 70, PCB_ANSIYELLOW , "Conference # to join (Enter)=none"},
/* 65 */   {145, 'L', 70, PCB_ANSIYELLOW , "Node # to Auto-Logoff (Enter)=none"},
/* 66 */   {145, 'L', 70, PCB_ANSIYELLOW , "Node # to View, (A)ll or (Enter)=none"},
/* 67 */   {145, 'L', 70, PCB_ANSIYELLOW , "Questionnaire # to Answer (Enter)=none"},
/* 68 */   {145, 'L', 70, PCB_ANSIYELLOW , "Enter the Filename to Upload (Enter)=none"},
/* 69 */   {145, 'L', 70, PCB_ANSIYELLOW , "Enter the DOOR # to Open (Enter)=none"},
/* 70 */   {145, 'L', 70, PCB_ANSIYELLOW , "Enter the Text to Scan for (Enter)=none"},
/* 71 */   {145, 'L', 70, PCB_ANSIYELLOW , "Search Filename (wildcards are OK) (Enter)=none"},
/* 72 */   {145, 'L', 70, PCB_ANSIGREEN  , "Date as (mmddyy) to search from (Enter)="},
/* 73 */   {150, 'L', 56, PCB_NOCHANGE   , "Private Discussion"},
/* 74 */   {145, 'L', 70, PCB_ANSIRED    , "Sorry, @FIRST@, you are not registered in Conference @OPTEXT@"},
/* 75 */   {150, 'L', 56, PCB_NOCHANGE   , "Open Discussion"},
/* 76 */   {150, 'L', 70, PCB_ANSIRED    , "CAUTION: Auto-Disconnect in (@OPTEXT@) min.!"},
/* 77 */   {145, 'L', 70, PCB_ANSIGREEN  , "Message # to Activate (Enter)=none"},
/* 78 */   {145, 'L', 70, PCB_ANSIRED    , "Sorry, @FIRST@, no mail found to read ..."},
/* 79 */   {145, 'L', 70, PCB_ANSIGREEN  , "Pack the message base (Enter)=no"},
/* 80 */   {145, 'L', 70, PCB_ANSIRED    , "Delete the caller log (Enter)=no"},
/* 81 */   {145, 'L', 70, PCB_ANSIGREEN  , "Purge older than (Enter)=010180"},
/* 82 */   {145, 'L', 70, PCB_ANSIGREEN  , "Renumber during repack (Enter)=no"},
/* 83 */   {145, 'L', 70, PCB_ANSIRED    , "NEW low starting Message # (Enter)=abort"},
/* 84 */   {145, 'L', 70, PCB_ANSIGREEN  , "Complete the Questionnaire (Enter)=no"},
/* 85 */   {145, 'L', 70, PCB_ANSIRED    , "Do you want to delete this line (Enter)=no"},
/* 86 */   {145, 'L', 70, PCB_ANSIGREEN  , "Pack the user file (Enter)=no"},
/* 87 */   {150, 'L', 74, PCB_ANSIRED    , "(@OPTEXT@) already exists.  Remove it (Y=Yes, N=No, C=Continue)"},
/* 88 */   {145, 'L', 70, PCB_ANSIGREEN  , "View other Conference members (Enter)=no"},
/* 89 */   {145, 'L', 70, PCB_ANSIGREEN  , "Purge RECEIVED+PRIVATE Msgs (Enter)=no"},
/* 90 */   {145, 'L', 70, PCB_ANSIGREEN  , "Exit to DOS (Enter)=no"},
/* 91 */   {145, 'L', 77, PCB_ANSIGREEN  , "Reference Message number purification proceeding ..."},
/* 92 */   {145, 'L', 70, PCB_ANSIRED    , "Wrong password entered, @FIRST@ ..."},
/* 93 */   {145, 'L', 70, PCB_ANSIRED    , "There is no such line, @FIRST@ ..."},
/* 94 */   {145, 'L', 70, PCB_ANSIRED    , "Sorry, @FIRST@, there is no Message #"},
/* 95 */   {145, 'L', 70, PCB_ANSIRED    , "Sorry, @FIRST@, you cannot kill Message #"},
/* 96 */   {145, 'L', 70, PCB_ANSIRED    , "Invalid Selection, @FIRST@!  Please try again ..."},
/* 97 */   {145, 'L', 60, PCB_ANSICYAN   , "Page ends in 30 seconds.  (Ctrl-K) Aborts ."},
/* 98 */   {150, 'L', 56, PCB_ANSIGREEN  , "Channel @OPTEXT@:~"},
/* 99 */   {145, 'L', 77, PCB_ANSIRED    , "  @FIRST@, press (Enter) for `no change' to any item ..."},
/* 100 */  {150, 'L', 30, PCB_ANSIWHITE  , "SHELL completed on (@OPTEXT@)."},
/* 101 */  {150, 'L', 50, PCB_ANSIGREEN  , "Page Length now set to @OPTEXT@."},
/* 102 */  {145, 'L', 70, PCB_ANSIRED    , "That user is not registered in this Conference ..."},
/* 103 */  {150, 'L', 56, PCB_ANSIWHITE  , "@INCONF@Questionnaire (@OPTEXT@) info saved."},
/* 104 */  {145, 'L', 70, PCB_ANSIRED    , "Automatic Logoff Completed ..."},
/* 105 */  {145, 'L', 70, PCB_ANSIGREEN  , "Keep `LOCKED OUT' users (Enter)=yes"},
/* 106 */  {145, 'L', 70, PCB_ANSIGREEN  , "Purge older than (Enter)=010180"},
/* 107 */  {145, 'L', 70, PCB_ANSIGREEN  , "Keep whose security => (Enter)=100"},
/* 108 */  {145, 'L', 70, PCB_ANSIWHITE  , "User file successfully packed."},
/* 109 */  {150, 'L', 56, PCB_ANSIWHITE  , "Joining channel #@OPTEXT@."},
/* 110 */  {145, 'L', 70, PCB_ANSIRED    , "Sorry, @FIRST@, the two passwords do not match!"},
/* 111 */  {145, 'L', 56, PCB_ANSIYELLOW , "Re-enter password to verify"},
/* 112 */  {145, 'L', 56, PCB_ANSIYELLOW , "Enter user's Security Level"},
/* 113 */  {145, 'L', 56, PCB_ANSIYELLOW , "Business or data phone # is"},
/* 114 */  {145, 'L', 56, PCB_ANSIYELLOW , "   Home or voice phone # is"},
/* 115 */  {145, 'R', 27, PCB_ANSIYELLOW , "  Registered in Conferences"},
/* 116 */  {145, 'L', 70, PCB_ANSIRED    , "@FIRST@, your time has been adjusted for our event."},
/* 117 */  {145, 'L', 70, PCB_ANSIRED    , "Response to the Question is Required!"},
/* 118 */  {145, 'L', 70, PCB_ANSIRED    , "Sorry, @FIRST@, only real names are allowed ..."},
/* 119 */  {145, 'L', 70, PCB_ANSIRED    , "Insufficient security for Viewing (@OPTEXT@)           "},
/* 120 */  {145, 'L', 70, PCB_ANSIRED    , "Sorry, @FIRST@, DOOR selected is not available."},
/* 121 */  {145, 'L', 70, PCB_ANSIRED    , "Sorry, @FIRST@, no Network is active."},
/* 122 */  {145, 'L', 77, PCB_ANSICYAN   , "Enter (U) for status while awaiting other caller ..."},
/* 123 */  {145, 'L', 56, PCB_ANSIWHITE  , "Thanks, @FIRST@, your registration information is saved."},
/* 124 */  {145, 'L', 70, PCB_ANSIRED    , "Sorry, @FIRST@, PACK not available from remote ..."},
/* 125 */  {145, 'L', 56, PCB_ANSIRED    , "Error saving message ..."},
/* 126 */  {145, 'L', 56, PCB_ANSIRED    , "Error in user file ..."},
/* 127 */  {150, 'L', 70, PCB_ANSIRED    , "CHANNEL BUSY!  Please wait a moment before typing..."},
/* 128 */  {145, 'L', 70, PCB_ANSIRED    , "Sorry, the Sysop is not currently available for CHAT!"},
/* 129 */  {145, 'L', 19, PCB_NOCHANGE   , "Sysop - Busy"},
/* 130 */  {145, 'L', 19, PCB_NOCHANGE   , "User - Busy"},
/* 131 */  {145, 'L', 19, PCB_NOCHANGE   , "DOS - Busy"},
/* 132 */  {145, 'L', 19, PCB_NOCHANGE   , "DOS - Not Busy"},
/* 133 */  {145, 'L', 19, PCB_NOCHANGE   , "Printer is Off"},
/* 134 */  {145, 'L', 19, PCB_NOCHANGE   , "Alarm is Off"},
/* 135 */  {145, 'L', 19, PCB_NOCHANGE   , "Page Bell is Off"},
/* 136 */  {150, 'L', 50, PCB_NOCHANGE   , "@OPTEXT@ has changed to a new handle:~"},
/* 137 */  {145, 'L', 60, PCB_ANSIRED    , "Bulletins have been updated since last time on, @FIRST@."},
/* 138 */  {145, 'L', 56, PCB_ANSIRED    , "Insufficient time remaining to download (@OPTEXT@)"},
/* 139 */  {145, 'L', 56, PCB_ANSIRED    , "Insufficient disk space for complete upload!"},
/* 140 */  {145, 'L', 56, PCB_ANSIRED    , "Sorry, @FIRST@, uploads are currently disabled!"},
/* 141 */  {145, 'L', 77, PCB_ANSIRED    , "7-E-1 Operation in Effect."},
/* 142 */  {145, 'L', 70, PCB_ANSIYELLOW , "DOS function to execute (Enter)=none"},
/* 143 */  {145, 'L', 77, PCB_ANSIYELLOW , "Enter your logon password below to continue ..."},
/* 144 */  {145, 'L', 56, PCB_ANSIRED    , "Excessive Main Command Line Errors!"},
/* 145 */  {145, 'L', 77, PCB_ANSIRED    , "(Ctrl-K) or (Ctrl-X) Aborts, (Ctrl-S) Suspends."},
/* 146 */  {145, 'L', 77, PCB_ANSIYELLOW , "Enter new length (0)=continuous, (Enter)=no change"},
/* 147 */  {145, 'L', 56, PCB_ANSIRED    , "Message Base Error!  Attempting to continue ..."},
/* 148 */  {145, 'L', 60, PCB_ANSIWHITE  , "Password (Dots will echo)"},
/* 149 */  {145, 'L', 77, PCB_NOCHANGE   , "Do you want graphics (Enter)=no"},
/* 150 */  {145, 'L', 77, PCB_ANSIYELLOW , "(R)e-enter user's name or (C)ontinue"},
/* 151 */  {145, 'L', 77, PCB_ANSIGREEN  , "Checking user file - please wait ..."},
/* 152 */  {145, 'R', 27, PCB_ANSIYELLOW , "Password (one word please)"},
/* 153 */  {145, 'L', 77, PCB_ANSIWHITE  , "Checking file transfer request.  Please wait, @FIRST@ ..."},
/* 154 */  {150, 'L', 56, PCB_ANSIRED    , "(@OPTEXT@) already exists on the system."},
/* 155 */  {145, 'L', 70, PCB_ANSIGREEN  , "Msg Scan: (A)ll, (C)urrent, (S)ince, (Q)uick, (L)ong, (Enter)=abort"},
/* 156 */  {145, 'L', 56, PCB_ANSIYELLOW , "Join Group CHAT Session (Enter)=no"},
/* 157 */  {145, 'L', 77, PCB_NOCHANGE   , "Awaiting Event Timer - All activity suspended ..."},
/* 158 */  {145, 'L', 77, PCB_ANSIWHITE  , "Sts Msg#    Ref#    To              From            Subject"},
/* 159 */  {145, 'L', 77, PCB_ANSIRED    , "(@OPTEXT@) Sorry, @FIRST@, download bytes left available are @BYTESLEFT@"},
/* 160 */  {145, 'L', 60, PCB_ANSIYELLOW , "Before beginning, enter a description of: @OPTEXT@"},
/* 161 */  {145, 'L', 77, PCB_ANSIGREEN  , "Begin description with (/) to make upload `Private'."},
/* 162 */  {145, 'L', 40, PCB_ANSIYELLOW , "Thanks for the file(s), @FIRST@!"},
/* 163 */  {150, 'L', 75, PCB_ANSIGREEN  , "(A) (C) (D) (E) (F) (H) (I) (L) (Q) (S) (SA) (SC) (SK) (SN) (U)"},
/* 164 */  {150, 'L', 76, PCB_ANSIGREEN  , "(A)bort, (C)ont Line Editor, (D)elete, (E)dit, (F)ull Scrn Editor, (H)elp,"},
/* 165 */  {145, 'L', 20, PCB_NOCHANGE   , "Modem Reset Error .."},
/* 166 */  {145, 'L', 75, PCB_ANSIGREEN  , "Thanks for calling, @FIRST@!"},
/* 167 */  {145, 'L', 75, PCB_ANSIYELLOW , "(A), (C), (D), (F), (L), (P), (Q), (S), (U), (#), (+/-)"},
/* 168 */  {145, 'L', 75, PCB_ANSIYELLOW , "A)dd, C)hange, D)el, F)ind, L)ist, P)rint, Q)uit, S)can, U)ndel, (#)"},
/* 169 */  {145, 'R', 12, PCB_ANSIYELLOW , "        To:~"},
/* 170 */  {145, 'R', 12, PCB_ANSIYELLOW , "      From:~"},
/* 171 */  {145, 'R', 12, PCB_ANSIYELLOW , "      Subj:~"},
/* 172 */  {145, 'L', 56, PCB_ANSIRED    , "Unable to write USER Record - Aborting!"},
/* 173 */  {150, 'L', 70, PCB_NOCHANGE   , "@OPTEXT@ has changed the topic to:~"},
/* 174 */  {145, 'L', 50, PCB_ANSIRED    , "Number of Users Purged:"},
/* 175 */  {145, 'L', 50, PCB_ANSIWHITE  , "Sysop CHAT active at~"},
/* 176 */  {145, 'L', 56, PCB_ANSIWHITE  , "Transfer Successful, @FIRST@."},
/* 177 */  {145, 'L', 40, PCB_ANSIRED    , "(@OPTEXT@) is an invalid filename!"},
/* 178 */  {150, 'L', 70, PCB_ANSIGREEN  , "(@X0C@TIMELEFT@@X0A min. left) (H)elp, Chat Command"},
/* 179 */  {150, 'L', 70, PCB_ANSIGREEN  , "(@X0C@TIMELEFT@@X0A min. left) (H)elp, Chat Command"},
/* 180 */  {150, 'L', 70, PCB_ANSIWHITE  , "This channel is now private.  Outsiders cannot join."},
/* 181 */  {150, 'L', 70, PCB_ANSIRED    , "That channel is private.  You cannot join it at this time."},
/* 182 */  {145, 'L', 77, PCB_ANSIRED    , "7-E-1 Operation Not Available!  Call using 8-N-1 Modem Settings!"},
/* 183 */  {145, 'L', 56, PCB_ANSIRED    , "PCBPACK Security Level Fail!"},
/* 184 */  {145, 'L', 60, PCB_ANSIWHITE  , "Reloading PCBoard.  Please wait ..."},
/* 185 */  {145, 'L', 40, PCB_ANSIRED    , "User Record Number Bad!"},
/* 186 */  {150, 'L', 60, PCB_ANSIWHITE  , "Press ESC to enter command mode."},
/* 187 */  {145, 'L', 30, PCB_NOCHANGE   , " Aborted using~"},
/* 188 */  {145, 'L', 30, PCB_NOCHANGE   , " Completed using~"},
/* 189 */  {150, 'L', 56, PCB_NOCHANGE   , "@OPTEXT@ has made the discussion private."},
/* 190 */  {145, 'L', 16, PCB_NOCHANGE   , "Ring Detected -~"},
/* 191 */  {145, 'L', 60, PCB_NOCHANGE   , "Press (Space) to acknowledge Page, (Esc) when done."},
/* 192 */  {145, 'L', 40, PCB_ANSICYAN   , "Minutes Used: @OPTEXT@"},
/* 193 */  {150, 'L', 70, PCB_ANSIYELLOW , "Subject (Enter)=no change"},
/* 194 */  {150, 'L', 40, PCB_ANSIRED    , "Message Security (H)=help"},
/* 195 */  {145, 'L', 50, PCB_ANSIGREEN  , "Msg # to Begin Search from (@OPTEXT@)"},
/* 196 */  {145, 'L', 60, PCB_ANSIYELLOW , "(@TIMELEFT@ min left), (H)elp, More"},
/* 197 */  {145, 'L', 70, PCB_ANSIGREEN  , "(@TIMELEFT@ min left), (H)elp, End of Message Command"},
/* 198 */  {145, 'L', 60, PCB_ANSIGREEN  , "Default Protocol Desired (Enter)=no change"},
/* 199 */  {150, 'L', 70, PCB_ANSIYELLOW , "     To (Enter)=`ALL'"},
/* 200 */  {150, 'L', 70, PCB_ANSIYELLOW , "Subject (Enter)=abort"},
/* 201 */  {145, 'L', 60, PCB_ANSIRED    , "Error in filename request!"},
/* 202 */  {145, 'L', 60, PCB_ANSICYAN   , "Welcome back to PCBoard~"},
/* 203 */  {145, 'L', 40, PCB_ANSIRED    , "Creating New Message Index File ."},
/* 204 */  {145, 'L', 50, PCB_ANSIWHITE  , "Online update of user's record completed."},
/* 205 */  {145, 'L', 77, PCB_ANSIRED    , "Only ASCII and Kermit Protocols supported at 7-E-1!"},
/* 206 */  {145, 'L', 40, PCB_ANSIRED    , "Number of Msgs Purged :"},
/* 207 */  {145, 'L', 40, PCB_ANSIRED    , "Number of Bytes Purged:"},
/* 208 */  {145, 'L', 60, PCB_ANSIWHITE  , "@X07@OPTEXT@ @X0Cnot found in user file."},
/* 209 */  {145, 'L', 60, PCB_ANSIYELLOW , "Two lines left before message is full, @FIRST@ ..."},
/* 210 */  {150, 'L', 60, PCB_NOCHANGE   , "@OPTEXT@ has entered this channel."},
/* 211 */  {150, 'L', 60, PCB_NOCHANGE   , "@OPTEXT@ has left this channel."},
/* 212 */  {145, 'L', 75, PCB_ANSIGREEN  , "(V)iew, (P)rint, (S)can, (D)elete Caller Log, (Enter)=quit"},
/* 213 */  {145, 'L', 65, PCB_ANSIGREEN  , "(V)iew, (P)rint Users, (Enter)=quit"},
/* 214 */  {145, 'L', 30, PCB_ANSIRED    , ") was not found in line"},
/* 215 */  {145, 'L', 50, PCB_NOCHANGE   , "Carrier Lost ..."},
/* 216 */  {145, 'L', 70, PCB_ANSIMAGENTA, "(Enter) Starts, (Ctrl-X) Aborts"},
/* 217 */  {145, 'L', 70, PCB_ANSIMAGENTA, "(Ctrl-X) Aborts Transfer"},
/* 218 */  {145, 'L', 56, PCB_ANSIRED    , "File Size is `0' - Aborting ..."},
/* 219 */  {145, 'L', 40, PCB_ANSIWHITE  , "Sysop CHAT ended at~"},
/* 220 */  {145, 'L', 70, PCB_ANSIGREEN  , "Edit: (T)o, (F)rom, (S)ubject, Refer (N)um, (R)ead, (P)rotection"},
/* 221 */  {150, 'L', 70, PCB_ANSIWHITE  , "`Echo' Message, (Enter)=@OPTEXT@"},
/* 222 */  {145, 'L', 70, PCB_ANSIYELLOW , "Text Entry Command"},
/* 223 */  {145, 'L', 70, PCB_ANSIYELLOW , "(H)elp, (1-@NUMDIR@), File List Command"},
/* 224 */  {145, 'L', 70, PCB_ANSIYELLOW , "(H)elp, (1-@NUMBLT@), Bulletin List Command"},
/* 225 */  {150, 'L', 60, PCB_ANSIRED    , "~wants to CHAT with you on Channel @OPTEXT@."},
/* 226 */  {150, 'L', 70, PCB_ANSIGREEN  , "Respond by typing (CHAT) (G) and then select channel @OPTEXT@."},
/* 227 */  {150, 'L', 70, PCB_ANSIYELLOW , "Node CHAT: (G)roup, (U)navailable, (H)elp, (Enter)=none"},
/* 228 */  {150, 'L', 70, PCB_ANSIYELLOW , "Node CHAT: (G)roup, (A)vailable, (H)elp, (Enter)=none"},
/* 229 */  {145, 'L', 60, PCB_ANSIRED    , "Sorry, @FIRST@, Node requested is not available for CHAT."},
/* 230 */  {150, 'L', 40, PCB_ANSIWHITE  , "Node CHAT ended at @OPTEXT@"},
/* 231 */  {150, 'L', 40, PCB_ANSIWHITE  , "Node CHAT entered at @OPTEXT@"},
/* 232 */  {150, 'L', 40, PCB_ANSIGREEN  , "Enter a new `topic' for Channel @OPTEXT@"},
/* 233 */  {145, 'L', 30, PCB_NOCHANGE   , "Refused to register."},
/* 234 */  {150, 'L', 70, PCB_ANSICYAN   , "Enter channel number (1-255), (L)ist channels or (Q)uit chat"},
/* 235 */  {150, 'L', 50, PCB_ANSIWHITE  , "Monitor Mode is now off."},
/* 236 */  {150, 'L', 50, PCB_ANSIWHITE  , "Monitor Mode is now on."},
/* 237 */  {150, 'L', 70, PCB_ANSIRED    , "There are no channels in use at this time."},
/* 238 */  {150, 'L', 69, PCB_ANSIGREEN  , "Enter your text. (Enter) alone to end.~"},
/* 239 */  {150, 'L', 23, PCB_ANSICYAN   , "Out to DOS"},
/* 240 */  {145, 'L', 50, PCB_ANSIYELLOW , "Filename to View (Enter)=none"},
/* 241 */  {145, 'L', 50, PCB_ANSIRED    , "Error executing View of file (@OPTEXT@)"},
/* 242 */  {145, 'L', 50, PCB_ANSIGREEN  , "View executed on file (@OPTEXT@)"},
/* 243 */  {145, 'L', 50, PCB_ANSIWHITE  , "Checking View request.  Please wait, @FIRST@ ..."},
/* 244 */  {150, 'L', 23, PCB_ANSICYAN   , "Chatting with Sysop"},
/* 245 */  {145, 'L', 40, PCB_ANSIGREEN  , "Default Protocol set to~"},
/* 246 */  {145, 'L', 50, PCB_ANSIRED    , "Error reading PCBPROT.DAT!  Aborting ..."},
/* 247 */  {150, 'L', 23, PCB_ANSICYAN   , "Answering Script"},
/* 248 */  {150, 'L', 50, PCB_ANSIYELLOW , "Enter the number of the node to CALL into chat"},
/* 249 */  {150, 'L', 70, PCB_ANSIYELLOW , "Enter node (#) to ignore, (C)ancel or (W)ho"},
/* 250 */  {150, 'L', 60, PCB_ANSIWHITE  , "Ignore Mode Cancelled"},
/* 251 */  {150, 'L', 70, PCB_ANSIWHITE  , "This channel is now public."},
/* 252 */  {150, 'L', 23, PCB_ANSICYAN   , "Rcvd Broadcast Message"},
/* 253 */  {145, 'L', 60, PCB_ANSIWHITE  , "Loading PCBPack module.  Please wait ..."},
/* 254 */  {145, 'L', 60, PCB_ANSIRED    , "PCBPack module not found!  Pack request unsuccessful ..."},
/* 255 */  {150, 'L', 40, PCB_ANSIWHITE  , "Ignoring Nodes:~"},
/* 256 */  {145, 'L', 50, PCB_ANSIRED    , "User already exists in the data base."},
/* 257 */  {145, 'L', 70, PCB_ANSIYELLOW , "What is the user's first name"},
/* 258 */  {145, 'L', 70, PCB_ANSIYELLOW , " What is the user's last name"},
/* 259 */  {145, 'L', 70, PCB_ANSIYELLOW , "What is your first name"},
/* 260 */  {145, 'L', 70, PCB_ANSIYELLOW , " What is your last name"},
/* 261 */  {150, 'L', 50, PCB_ANSIWHITE  , "Silent Mode is now off."},
/* 262 */  {150, 'L', 50, PCB_ANSIWHITE  , "Silent Mode is now on."},
/* 263 */  {150, 'L', 70, PCB_ANSIYELLOW , "Send private message to Node (#), (C)ancel or (S)how users"},
/* 264 */  {145, 'L', 65, PCB_ANSIGREEN  , "Please wait - Adding @USER@ to Quick Index File ..."},
/* 265 */  {145, 'L', 70, PCB_ANSIYELLOW , "City and State calling from"},
/* 266 */  {145, 'L', 70, PCB_ANSIYELLOW , " Reg. Exp. Date (as mmddyy)"},
/* 267 */  {145, 'L', 70, PCB_ANSIYELLOW , "   Exp. Reg. Security Level"},
/* 268 */  {145, 'L', 70, PCB_ANSIYELLOW , " Exp. Reg. Conference Info."},
/* 269 */  {145, 'L', 70, PCB_ANSIYELLOW , "Special Comment/Record Info"},
/* 270 */  {145, 'L', 60, PCB_ANSIRED    , "Sorry, @OPTEXT@ bps is not supported ..."},
/* 271 */  {145, 'L', 60, PCB_ANSIRED    , "@OPTEXT@ bps is supported from @OFFHOURS@."},
/* 272 */  {145, 'L', 40, PCB_ANSIRED    , "System is currently unavailable ..."},
/* 273 */  {145, 'L', 60, PCB_ANSIRED    , "@FIRST@, your record has been updated with changes made."},
/* 274 */  {145, 'L', 70, PCB_ANSIYELLOW , "Node # to Drop to DOS (Enter)=none"},
/* 275 */  {145, 'L', 56, PCB_ANSIRED    , "Sorry, @FIRST@, no Bulletins are presently available."},
/* 276 */  {145, 'L', 56, PCB_ANSIRED    , "Sorry, @FIRST@, no DOORS are presently available."},
/* 277 */  {145, 'L', 60, PCB_ANSIRED    , "Sorry, @FIRST@, no Directories are presently available."},
/* 278 */  {145, 'L', 60, PCB_ANSIRED    , "Sorry, @FIRST@, no Conferences are presently available!"},
/* 279 */  {145, 'L', 77, PCB_ANSIYELLOW , " ---   ---------------------   -----------------------------"},
/* 280 */  {145, 'L', 60, PCB_ANSIGREEN  , "Protocol Type for Transfer, (Enter) or (N)=abort"},
/* 281 */  {145, 'L', 56, PCB_ANSIRED    , "(@OPTEXT@) is an invalid Conference selection!"},
/* 282 */  {145, 'L', 56, PCB_ANSIRED    , "(@OPTEXT@) is an invalid DOOR selection!"},
/* 283 */  {145, 'L', 60, PCB_ANSIWHITE  , "Scanning Directory"},
/* 284 */  {145, 'L', 60, PCB_ANSIGREEN  , "Page Length is currently set to"},
/* 285 */  {145, 'L', 56, PCB_ANSIRED    , "Uploads Not Accepted on File Format (@OPTEXT@)"},
/* 286 */  {145, 'L', 70, PCB_ANSIGREEN  , " (#)   Status                  User"},
/* 287 */  {145, 'L', 56, PCB_ANSIWHITE  , "Graphics mode is now on, @FIRST@ ..."},
/* 288 */  {145, 'L', 56, PCB_NOCHANGE   , "Graphics mode is now off, @FIRST@ ..."},
/* 289 */  {145, 'L', 56, PCB_ANSIWHITE  , "Logoff Information Saved."},
/* 290 */  {145, 'L', 60, PCB_ANSIRED    , "Transfer Aborted ..."},
/* 291 */  {145, 'L', 56, PCB_ANSIRED    , "Sorry, @FIRST@, you entered an invalid Bulletin #!"},
/* 292 */  {145, 'L', 56, PCB_ANSIRED    , "Sorry, @FIRST@, you entered an invalid Directory #!"},
/* 293 */  {150, 'L', 49, PCB_NOCHANGE   , "Event @OPTEXT@ ran at~"},
/* 294 */  {150, 'L', 49, PCB_NOCHANGE   , "Caller Exited to DOS at @OPTEXT@"},
/* 295 */  {150, 'L', 56, PCB_NOCHANGE   , "Viewed Text file (@OPTEXT@)"},
/* 296 */  {145, 'L', 55, PCB_ANSIYELLOW , "Scan Message Base Since `Last Read' (Enter)=yes"},
/* 297 */  {145, 'L', 40, PCB_ANSIGREEN  , "New Info"},
/* 298 */  {150, 'L', 60, PCB_ANSIGREEN  , "Enter text of private message below:"},
/* 299 */  {150, 'L', 65, PCB_ANSIRED    , "PRIVATE MESSAGE!  @X0BTo respond privately use: SEND @OPTEXT@"},
/* 300 */  {145, 'L', 40, PCB_ANSIYELLOW , "Filename to Download (Enter)=@OPTEXT@"},
/* 301 */  {145, 'R', 27, PCB_ANSIYELLOW , "Carbon Copy To (Enter)=none"},
/* 302 */  {150, 'L', 40, PCB_NOCHANGE   , "Opened Door (@OPTEXT@) at~"},
/* 303 */  {145, 'L', 23, PCB_ANSICYAN   , "No Caller this Node"},
/* 304 */  {145, 'L', 23, PCB_ANSICYAN   , "Available for CHAT"},
/* 305 */  {145, 'L', 23, PCB_ANSICYAN   , "Out of Code in DOOR"},
/* 306 */  {145, 'L', 23, PCB_ANSICYAN   , "Auto Logoff Pending"},
/* 307 */  {150, 'L', 23, PCB_ANSICYAN   , "DOS Recycle Pending"},
/* 308 */  {145, 'L', 23, PCB_ANSICYAN   , "Unavailable for CHAT"},
/* 309 */  {145, 'L', 23, PCB_ANSICYAN   , "Transferring a File"},
/* 310 */  {145, 'L', 23, PCB_ANSICYAN   , "Entering a Message"},
/* 311 */  {145, 'L', 23, PCB_ANSICYAN   , "CHATTING with Group"},
/* 312 */  {145, 'L', 23, PCB_ANSICYAN   , "Drop to DOS Pending"},
/* 313 */  {150, 'L', 60, PCB_NOCHANGE   , "@OPTEXT@ has made the discussion public."},
/* 314 */  {150, 'L', 60, PCB_ANSIRED    , "Channel 1 cannot be made private."},
/* 315 */  {145, 'L', 65, PCB_ANSIRED    , "Incorrect Download Password for File (@OPTEXT@)"},
/* 316 */  {145, 'L', 65, PCB_ANSIRED    , "Incorrect Upload Password for File (@OPTEXT@)"},
/* 317 */  {145, 'L', 65, PCB_ANSIRED    , "Incorrect View Password for File (@OPTEXT@)"},
/* 318 */  {145, 'L', 65, PCB_ANSIRED    , "Incorrect Password for DOOR (@OPTEXT@)"},
/* 319 */  {150, 'L', 60, PCB_ANSIRED    , "That node is not in group chat!"},
/* 320 */  {150, 'L', 75, PCB_ANSIWHITE  , "Preparing file(s) for download.  Please wait."},
/* 321 */  {145, 'L', 30, PCB_NOCHANGE   , "Bulletin Read:~"},
/* 322 */  {145, 'L', 30, PCB_ANSIRED    , "Input File Name"},
/* 323 */  {145, 'R', 16, PCB_ANSIYELLOW , "File Selected: ~"},
/* 324 */  {145, 'R', 16, PCB_ANSIYELLOW , "Protocol Type: ~"},
/* 325 */  {145, 'R', 27, PCB_ANSIYELLOW , "Select Conference(s)"},
/* 326 */  {145, 'L', 60, PCB_ANSIRED    , "(@OPTEXT@) not found on disk!"},
/* 327 */  {145, 'L', 60, PCB_ANSIGREEN  , "I'm back!  Thanks for waiting~"},
/* 328 */  {150, 'L', 40, PCB_ANSIGREEN  , "@OPTEXT@ Joined"},
/* 329 */  {145, 'L', 14, PCB_ANSIYELLOW , "Local password"},
/* 330 */  {145, 'L', 50, PCB_ANSIGREEN  , "Enter the Message # to Kill (Enter)=none"},
/* 331 */  {150, 'L', 76, PCB_ANSIRED    , "Punctuation Error:  Quotes may be necessary around the search criteria."},
/* 332 */  {150, 'L', 40, PCB_NOCHANGE   , "Back from DOS at @OPTEXT@"},
/* 333 */  {145, 'L', 40, PCB_ANSIGREEN  , "Hello, this is @OPTEXT@.~~"},
/* 334 */  {145, 'L', 40, PCB_ANSIWHITE  , "Message Restored:~"},
/* 335 */  {145, 'L', 40, PCB_ANSIRED    , "Message Killed:~"},
/* 336 */  {145, 'L', 40, PCB_NOCHANGE   , "Comment Left:~"},
/* 337 */  {145, 'L', 40, PCB_NOCHANGE   , "Message Left:~"},
/* 338 */  {145, 'L', 70, PCB_ANSIWHITE  , "Saving Comment #"},
/* 339 */  {145, 'L', 70, PCB_ANSIWHITE  , "Saving Message #"},
/* 340 */  {145, 'L', 70, PCB_NOCHANGE   , "    (Enter) continues with display"},
/* 341 */  {145, 'L', 70, PCB_NOCHANGE   , "    (Y) yes, continue with display"},
/* 342 */  {145, 'L', 70, PCB_NOCHANGE   , "    (N) no, stop displaying this text"},
/* 343 */  {145, 'L', 70, PCB_NOCHANGE   , "    (NS) continue reading in non-stop mode"},
/* 344 */  {150, 'L', 23, PCB_ANSICYAN   , "Drop to DOS - Urgent"},
/* 345 */  {150, 'L', 70, PCB_ANSIRED    , "Force logoff now (`N'=wait until caller logs off, then drop to DOS)"},
/* 346 */  {145, 'L', 70, PCB_NOCHANGE   , "    (V) View a file, then continue displaying files"},
/* 347 */  {145, 'R', 15, PCB_ANSIGREEN  , "  # Msgs Found:"},
/* 348 */  {150, 'L', 70, PCB_ANSIYELLOW , "Node # to Recycle through DOS (Enter)=none"},
/* 349 */  {145, 'L', 50, PCB_NOCHANGE   , "Password Failure (@OPTEXT@)"},
/* 350 */  {145, 'L', 56, PCB_ANSIWHITE  , "Expert mode is now on, @FIRST@ ..."},
/* 351 */  {145, 'L', 56, PCB_ANSIWHITE  , "Expert mode is now off, @FIRST@ ..."},
/* 352 */  {145, 'L', 70, PCB_ANSIYELLOW , "Files: (1-@NUMDIR@), (A), (U), (Enter)=none"},
/* 353 */  {145, 'L', 70, PCB_ANSIYELLOW , "Files: (1-@NUMDIR@), (A)ll, (U)ploads, (Enter)=none"},
/* 354 */  {145, 'L', 75, PCB_NOCHANGE   , "Alt-> F=Out I=In N=Next X=DOS P=Printer T=FmFeed F1/F2=Time F9/F10=Security"},
/* 355 */  {145, 'L', 78, PCB_NOCHANGE   , "1=SyPrv 2=LkOut 3=Print 4=Bell 5=SHELL 6=Reg 7=Alarm 8=HngUp 9=Screen 10=Chat"},
/* 356 */  {145, 'L', 50, PCB_ANSIRED    , "Network Delay - Please Wait, @FIRST@ ..."},
/* 357 */  {145, 'R', 15, PCB_ANSIYELLOW , "Download Time:~"},
/* 358 */  {145, 'R', 15, PCB_ANSIYELLOW , "Download Size:~"},
/* 359 */  {145, 'R', 15, PCB_ANSIYELLOW , "Total Will Be:~"},
/* 360 */  {145, 'R', 14, PCB_ANSIYELLOW , "Upload Drive :"},
/* 361 */  {145, 'L', 30, PCB_ANSIGREEN  , " Bytes Free Disk Space"},
/* 362 */  {145, 'L', 56, PCB_ANSIRED    , "Thread Read Terminated ..."},
/* 363 */  {145, 'L', 56, PCB_ANSIRED    , "Message Number Memorized ..."},
/* 364 */  {145, 'L', 56, PCB_ANSIRED    , "Message Text Search Terminated ..."},
/* 365 */  {150, 'L', 56, PCB_ANSIRED    , "Insufficient memory for CHAT buffers."},
/* 366 */  {145, 'R', 14, PCB_ANSIYELLOW , "Upload Status:"},
/* 367 */  {145, 'L', 70, PCB_ANSIRED    , "  Screened Before Posting"},
/* 368 */  {145, 'L', 70, PCB_ANSIRED    , "  Posted Immediately"},
/* 369 */  {145, 'L', 70, PCB_NOCHANGE   , "Caller Num.:"},
/* 370 */  {150, 'L', 56, PCB_ANSIRED    , "Unable to open CHAT file."},
/* 371 */  {145, 'L', 30, PCB_NOCHANGE   , "Lst Date On:~"},
/* 372 */  {145, 'L', 30, PCB_NOCHANGE   , "Expire Date:~"},
/* 373 */  {145, 'L', 30, PCB_NOCHANGE   , "# Times On :"},
/* 374 */  {145, 'L', 30, PCB_NOCHANGE   , "Page Length:"},
/* 375 */  {145, 'L', 30, PCB_NOCHANGE   , "Expert Mode: On"},
/* 376 */  {145, 'L', 30, PCB_NOCHANGE   , "Expert Mode: Off"},
/* 377 */  {145, 'L', 30, PCB_NOCHANGE   , "Security Lv:"},
/* 378 */  {145, 'L', 30, PCB_NOCHANGE   , "# Downloads:"},
/* 379 */  {145, 'L', 30, PCB_NOCHANGE   , "# Uploads  :"},
/* 380 */  {145, 'L', 30, PCB_NOCHANGE   , "Bytes Avail:"},
/* 381 */  {145, 'L', 30, PCB_NOCHANGE   , "L/Msg. Read:"},
/* 382 */  {145, 'L', 30, PCB_NOCHANGE   , "High Msg. #:"},
/* 383 */  {145, 'L', 30, PCB_NOCHANGE   , "Active Msgs:"},
/* 384 */  {145, 'L', 30, PCB_NOCHANGE   , "Tr/Protocol:~"},
/* 385 */  {145, 'L', 40, PCB_ANSIYELLOW , "Operational Languages Available:"},
/* 386 */  {145, 'L', 56, PCB_ANSIRED    , "Alternative Language Operation Not Available."},
/* 387 */  {145, 'L', 56, PCB_ANSIYELLOW , "Enter Language # to use (Enter)=no change"},
/* 388 */  {145, 'L', 56, PCB_ANSIWHITE  , "English Language is now active."},
/* 389 */  {145, 'L', 56, PCB_ANSIRED    , "Language Requested Not Available."},
/* 390 */  {145, 'L', 30, PCB_ANSIGREEN  , " minutes (approximate)"},
/* 391 */  {145, 'L', 40, PCB_ANSIRED    , "SHELL Batch file Missing ("},
/* 392 */  {145, 'L', 20, PCB_NOCHANGE   , "Resetting Packet ..."},
/* 393 */  {145, 'L', 20, PCB_NOCHANGE   , "Resetting Modem ..."},
/* 394 */  {145, 'L', 40, PCB_NOCHANGE   , "System is Ready For Callers"},
/* 395 */  {145, 'L', 12, PCB_ANSIYELLOW , " min. left)"},
/* 396 */  {145, 'L', 70, PCB_ANSIYELLOW , "(@X0C@TIMELEFT@@X0E min. left) @INCONF@Command"},
/* 397 */  {145, 'L', 40, PCB_ANSIWHITE  , "Scanning~"},
/* 398 */  {145, 'L', 50, PCB_ANSIWHITE  , "Scanning Main (0)"},
/* 399 */  {145, 'L', 12, PCB_NOCHANGE   , " Conference"},
/* 400 */  {145, 'L', 12, PCB_NOCHANGE   , "Main Board"},
/* 401 */  {150, 'L', 56, PCB_ANSIRED    , "Error in Chat File format, aborting..."},
/* 402 */  {150, 'L', 56, PCB_ANSIRED    , "Found: @X07@OPTEXT@"},
/* 403 */  {145, 'L', 40, PCB_ANSIRED    , "Abort your entry (Enter)=no"},
/* 404 */  {145, 'L', 56, PCB_ANSIWHITE  , "Text Entry Aborted ..."},
/* 405 */  {145, 'L', 40, PCB_ANSIYELLOW , "Delete Line #"},
/* 406 */  {145, 'L', 50, PCB_ANSIRED    , "Sorry, @FIRST@, unable to Insert another line!"},
/* 407 */  {145, 'L', 40, PCB_ANSIYELLOW , "Before Line #"},
/* 408 */  {145, 'L', 42, PCB_ANSIYELLOW , "Which line do you want to edit, @FIRST@"},
/* 409 */  {145, 'L', 40, PCB_NOCHANGE   , "Operator Paged at~"},
/* 410 */  {145, 'L', 20, PCB_NOCHANGE   , "Hanging Up Phone ..."},
/* 411 */  {145, 'L', 20, PCB_NOCHANGE   , "Going Off-Hook ..."},
/* 412 */  {150, 'L', 56, PCB_ANSICYAN   , "@OPTEXT@ Abandoned"},
/* 413 */  {145, 'L', 60, PCB_ANSIRED    , "(@OPTEXT@) Menu Selection is not available, @FIRST@."},
/* 414 */  {145, 'L', 60, PCB_ANSIYELLOW , "(@OPTEXT@) Enter the password for uploading"},
/* 415 */  {145, 'L', 40, PCB_ANSIYELLOW , "   Enter password to open the DOOR"},
/* 416 */  {145, 'L', 60, PCB_ANSIYELLOW , "(@OPTEXT@) Enter the password for viewing"},
/* 417 */  {145, 'L', 60, PCB_ANSIYELLOW , "(@OPTEXT@) Enter the password for downloading"},
/* 418 */  {145, 'L', 40, PCB_ANSIGREEN  , "Press (Enter) to continue"},
/* 419 */  {145, 'L', 56, PCB_ANSIRED    , "Insufficient security for DOOR (@OPTEXT@)"},
/* 420 */  {145, 'L', 72, PCB_ANSIGREEN  , "Edit: (T)o, (F)rom, (S)ubject, Refer (N)um, (R)ead, (P)rotection, (E)cho"},
/* 421 */  {145, 'L', 56, PCB_ANSIRED    , "Sorry, @FIRST@, no NEWS file is available!"},
/* 422 */  {145, 'R', 16, PCB_ANSIYELLOW , "  Msgs For You:~"},
/* 423 */  {145, 'R', 16, PCB_ANSIYELLOW , " Msgs From You:~"},
/* 424 */  {145, 'L', 70, PCB_ANSIYELLOW , "(H)elp, (@OPTEXT@), Message Scan Command"},
/* 425 */  {145, 'L', 70, PCB_ANSIYELLOW , "(H)elp, (@OPTEXT@), Message Read Command"},
/* 426 */  {150, 'L', 70, PCB_ANSIRED    , "No message number has been memorized!"},
/* 427 */  {150, 'L', 70, PCB_ANSIRED    , "The user may be busy.  Attempt to CALL into chat anyway"},
/* 428 */  {145, 'L', 56, PCB_ANSIRED    , "Insufficient Download Security for (@OPTEXT@)"},
/* 429 */  {150, 'L', 56, PCB_ANSIWHITE  , "Caller Log Viewed"},
/* 430 */  {150, 'L', 54, PCB_ANSIWHITE  , "Directory Scan for (@OPTEXT@)"},
/* 431 */  {150, 'L', 56, PCB_ANSIRED    , "User File Viewed"},
/* 432 */  {145, 'L', 56, PCB_ANSIRED    , "Sorry, @FIRST@, Insufficient Security for `From' edit!"},
/* 433 */  {150, 'L', 77, PCB_ANSIWHITE  , "This system is set to test uploaded files.  This can be a lengthy process."},
/* 434 */  {150, 'L', 70, PCB_ANSIRED    , "(H)ang up now, or press any other key to remain online..."},
/* 435 */  {150, 'L', 70, PCB_ANSIWHITE  , "Hanging up now.  Thank you for the upload(s)."},
/* 436 */  {145, 'L', 50, PCB_ANSIWHITE  , " has exited to DOS.  Please wait ..."},
/* 437 */  {150, 'L', 60, PCB_ANSIRED    , "Upload aborted ..."},
/* 438 */  {145, 'L', 77, PCB_ANSIYELLOW , "  Enter (Oldtext;Newtext) or (Enter) alone for `no change'."},
/* 439 */  {145, 'L', 43, PCB_ANSIWHITE  , "Date:                               Number:"},
/* 440 */  {150, 'L', 43, PCB_NOCHANGE   , "  To:"},
/* 441 */  {150, 'L', 77, PCB_NOCHANGE   , "HAS REPLIES"},
/* 442 */  {150, 'L', 50, PCB_NOCHANGE   , "From:"},
/* 443 */  {150, 'L', 50, PCB_NOCHANGE   , "(N/A)"},
/* 444 */  {150, 'L', 50, PCB_NOCHANGE   , "NO"},
/* 445 */  {150, 'L', 60, PCB_NOCHANGE   , "RECEIVER ONLY"},
/* 446 */  {150, 'L', 60, PCB_NOCHANGE   , "GROUP PASSWORD"},
/* 447 */  {150, 'L', 60, PCB_NOCHANGE   , "SENDER PASSWORD"},
/* 448 */  {150, 'L', 60, PCB_NOCHANGE   , "PUBLIC MESSAGE"},
/* 449 */  {150, 'L', 70, PCB_ANSIWHITE  , "Uploading will lose the Flagged Files list.  Continue with upload"},
/* 450 */  {145, 'L', 40, PCB_NOCHANGE   , "(Error Correcting Modem Detected)"},
/* 451 */  {150, 'L', 30, PCB_NOCHANGE   , "Refer#"},
/* 452 */  {150, 'L', 30, PCB_NOCHANGE   , "Read:"},
/* 453 */  {150, 'L', 30, PCB_NOCHANGE   , "Subj:"},
/* 454 */  {145, 'L', 60, PCB_ANSIRED    , "Not Using Sysop Record #1 - Pack not Available!"},
/* 455 */  {150, 'L', 30, PCB_NOCHANGE   , "Status:"},
/* 456 */  {145, 'L', 50, PCB_ANSIRED    , "Pack Message Base Before Continuing!"},
/* 457 */  {145, 'L', 60, PCB_ANSIRED    , "No Security Level Match in PWRD File!"},
/* 458 */  {145, 'L', 30, PCB_NOCHANGE   , "Free Msg #s:"},
/* 459 */  {145, 'L', 30, PCB_NOCHANGE   , "Low Msg. # :"},
/* 460 */  {145, 'L', 30, PCB_NOCHANGE   , "Defined #'s:"},
/* 461 */  {145, 'L', 50, PCB_ANSIGREEN  , "Generate ONLY a New Index File (Enter)=no"},
/* 462 */  {145, 'L', 60, PCB_ANSIRED    , "Assign More Message BLOCKS using PCBSetup!"},
/* 463 */  {150, 'L', 70, PCB_ANSIWHITE  , "Chat Echo disabled.  Use the ECHO command to re-enable it."},
/* 464 */  {150, 'L', 70, PCB_ANSIWHITE  , "Chat Echo enabled."},
/* 465 */  {145, 'L', 56, PCB_ANSIYELLOW , "Move Message to what Conference #"},
/* 466 */  {150, 'L', 56, PCB_NOCHANGE   , " / FILE"},
/* 467 */  {145, 'L', 56, PCB_NOCHANGE   , "Message Moved: #"},
/* 468 */  {150, 'L', 54, PCB_NOCHANGE   , " / LIST"},
/* 469 */  {145, 'L', 54, PCB_ANSIYELLOW , "Recent Uploads"},
/* 470 */  {145, 'L', 77, PCB_NOCHANGE   , "(Esc) Exit, () () (PgUp) (PgDn) (Home) (End) Scrolls, (Space) Tags/Untags"},
/* 471 */  {145, 'L', 30, PCB_NOCHANGE   , "Scroll Lines Above Cursor:"},
/* 472 */  {145, 'L', 30, PCB_NOCHANGE   , "Scroll Lines Below Cursor:"},
/* 473 */  {145, 'L', 25, PCB_NOCHANGE   , "(Generic Message)"},
/* 474 */  {150, 'L', 72, PCB_ANSIGREEN  , "(G)oodbye after Batch, (A)bort, Change (P)rotocol, (Enter)=continue"},
/* 475 */  {145, 'L', 56, PCB_ANSIMAGENTA, "(Ready to Send in Batch Mode)"},
/* 476 */  {150, 'L', 70, PCB_ANSIRED    , "The file received is wider than 79 characters."},
/* 477 */  {150, 'L', 70, PCB_ANSIYELLOW , "(S)ave or (A)bort message"},
/* 478 */  {145, 'L', 56, PCB_ANSIWHITE  , "Batch Transfer Ended."},
/* 479 */  {145, 'L', 30, PCB_ANSIRED    , "Output File Name"},
/* 480 */  {145, 'R', 21, PCB_ANSIYELLOW , "Batch Download Time:~"},
/* 481 */  {145, 'R', 21, PCB_ANSIYELLOW , "Batch Download Size:~"},
/* 482 */  {145, 'R', 22, PCB_ANSIYELLOW , "Batch Protocol Type: ~"},
/* 483 */  {145, 'L', 56, PCB_ANSIGREEN  , "(A)ll Abort Detected. Continue with scan (Enter)=yes"},
/* 484 */  {145, 'L', 72, PCB_ANSIGREEN  , "Conf:                            Read Type: GENERAL"},
/* 485 */  {145, 'L', 72, PCB_ANSIGREEN  , "Conf:                            Read Type: THREAD READ"},
/* 486 */  {145, 'L', 72, PCB_ANSIGREEN  , "Conf:                            Read Type: TEXT SCAN"},
/* 487 */  {145, 'L', 72, PCB_ANSIGREEN  , "Conf:                            Read Type: MAIL FOR YOU"},
/* 488 */  {145, 'L', 72, PCB_ANSIGREEN  , "Conf:                            Read Type: MAIL FROM YOU"},
/* 489 */  {145, 'L', 72, PCB_ANSIGREEN  , "Conf:                            Read Type: TO OR FROM YOU"},
/* 490 */  {145, 'L', 65, PCB_ANSIGREEN  , "(G)oodbye after Download, (A)bort Download (Enter)=continue"},
/* 491 */  {150, 'L', 60, PCB_ANSIRED    , "Attached File: @X07@OPTEXT@~~"},
/* 492 */  {145, 'L', 60, PCB_ANSIRED    , "Capture Aborted.  Read Pointers Restored ..."},
/* 493 */  {145, 'L', 60, PCB_ANSIRED    , "Goodbye in 10 seconds. (H)ang up now or (Ctrl-K) to cancel"},
/* 494 */  {145, 'L', 60, PCB_ANSIGREEN  , "Capture file is empty - nothing to download."},
/* 495 */  {145, 'L', 60, PCB_ANSIYELLOW , "Total Messages Captured for Download ->"},
/* 496 */  {145, 'L', 60, PCB_ANSIMAGENTA, "Sending File(s) - Start your download ..."},
/* 497 */  {145, 'L', 23, PCB_NOCHANGE   , "Logging into System    "},
/* 498 */  {150, 'L', 30, PCB_ANSIYELLOW , "Use Full Screen Editor"},
/* 499 */  {145, 'L', 70, PCB_ANSICYAN   , "Full Screen Editor requires ANSI capability"},
/* 500 */  {145, 'L', 70, PCB_ANSIYELLOW , "Download Flagged Files"},
/* 501 */  {145, 'L', 25, PCB_ANSIRED    , "New Bulletin(s):"},
/* 502 */  {145, 'L', 30, PCB_NOCHANGE   , "Attempted to log on as:~"},
/* 503 */  {145, 'L', 75, PCB_ANSIYELLOW , "Perform (S)oundex Search, (R)e-enter User's Name or (C)ontinue"},
/* 504 */  {145, 'L', 75, PCB_ANSIYELLOW , "(U)se Found Name, (S)earch for more, (R)e-enter Name or (C)ontinue"},
/* 505 */  {145, 'L', 70, PCB_ANSIYELLOW , "QUOTE: Starting line number, (Q) to Quit"},
/* 506 */  {145, 'L', 70, PCB_ANSIYELLOW , "QUOTE: Ending line number, (Q) to Quit"},
/* 507 */  {145, 'L', 60, PCB_ANSIWHITE  , "Compressing capture file, please wait..."},
/* 508 */  {145, 'L', 50, PCB_ANSICYAN   , "Insufficient Memory for Operation @OPTEXT@"},
/* 509 */  {145, 'L', 19, PCB_NOCHANGE   , "Sysop - Not Busy"},
/* 510 */  {145, 'L', 19, PCB_NOCHANGE   , "User - Not Busy"},
/* 511 */  {145, 'L', 19, PCB_NOCHANGE   , "PCBSysMgr"},
/* 512 */  {145, 'L', 19, PCB_NOCHANGE   , "PCBFiler"},
/* 513 */  {145, 'L', 19, PCB_NOCHANGE   , "PCBSetup"},
/* 514 */  {145, 'L', 19, PCB_NOCHANGE   , "SYSTEM Statistics"},
/* 515 */  {145, 'L', 19, PCB_NOCHANGE   , "PCBMoni"},
/* 516 */  {145, 'L', 19, PCB_NOCHANGE   , "Reset Stats"},
/* 517 */  {145, 'L', 19, PCB_NOCHANGE   , "No Printer"},
/* 518 */  {145, 'L', 19, PCB_NOCHANGE   , "Printer is On"},
/* 519 */  {145, 'L', 19, PCB_NOCHANGE   , "Alarm is On"},
/* 520 */  {145, 'L', 19, PCB_NOCHANGE   , "Page Bell is On"},
/* 521 */  {145, 'L', 75, PCB_NOCHANGE   , "Log in as a regular user.  Callers will get a busy signal."},
/* 522 */  {145, 'L', 75, PCB_NOCHANGE   , "Log in as a regular user.  RING Alert will be activated."},
/* 523 */  {145, 'L', 75, PCB_NOCHANGE   , "Toggle printer off or on.  When on, caller log is echoed to printer."},
/* 524 */  {145, 'L', 75, PCB_NOCHANGE   , "Run PCBoard System Manager for User File maintenance."},
/* 525 */  {145, 'L', 75, PCB_NOCHANGE   , "Choose between System-Wide and Node-Specific Statistics Display"},
/* 526 */  {145, 'L', 75, PCB_NOCHANGE   , "Log in as the Sysop.  Callers will get a busy signal."},
/* 527 */  {145, 'L', 75, PCB_NOCHANGE   , "Log in as the Sysop.  RING Alert will be activated."},
/* 528 */  {145, 'L', 75, PCB_NOCHANGE   , "Toggle `Page Bell' on or off.  System will BEEP when caller pages you."},
/* 529 */  {145, 'L', 75, PCB_NOCHANGE   , "Run PCBFiler for File Directory maintenance."},
/* 530 */  {145, 'L', 75, PCB_NOCHANGE   , "Run PCBMoni to monitor NODE activity"},
/* 531 */  {145, 'L', 75, PCB_NOCHANGE   , "Drop to DOS.  Callers will get a busy signal."},
/* 532 */  {145, 'L', 75, PCB_NOCHANGE   , "Drop to DOS.  Callers will NOT get a busy signal.  Phone will ring!"},
/* 533 */  {145, 'L', 75, PCB_NOCHANGE   , "Toggle `Caller Alarm' on or off.  System BEEPs as caller logs on, etc."},
/* 534 */  {145, 'L', 75, PCB_NOCHANGE   , "Run PCBSetup to change PCBoard configuration."},
/* 535 */  {145, 'L', 75, PCB_NOCHANGE   , "Reset Node/System Statistics to Zero"},
/* 536 */  {145, 'L', 30, PCB_NOCHANGE   , "No Modem Selected"},
/* 537 */  {145, 'L', 15, PCB_NOCHANGE   , "Last Caller:"},
/* 538 */  {145, 'L',  7, PCB_NOCHANGE   , "Calls:"},
/* 539 */  {145, 'L',  7, PCB_NOCHANGE   , "Msgs:"},
/* 540 */  {145, 'L',  7, PCB_NOCHANGE   , "D/Ls:"},
/* 541 */  {145, 'L',  7, PCB_NOCHANGE   , "U/Ls:"},
/* 542 */  {145, 'L', 40, PCB_ANSIGREEN  , "Press (Esc) to Exit  (Ctrl-Z) for Help"},
/* 543 */  {145, 'L', 30, PCB_ANSIGREEN  , "(Ins/Ctrl-V) Mode: Overwrite"},
/* 544 */  {145, 'L', 30, PCB_ANSIGREEN  , "(Ins/Ctrl-V) Mode: Insert"},
/* 545 */  {145, 'L', 50, PCB_ANSIYELLOW , "(@OPTEXT@), Set your Last Message Read to"},
/* 546 */  {145, 'L', 50, PCB_ANSIRED    , "Last Message Read now set to @OPTEXT@."},
/* 547 */  {145, 'L', 15, PCB_NOCHANGE   , "Unlimited"},
/* 548 */  {145, 'L', 75, PCB_NOCHANGE   , "    (F) Flag a file for later download, then continue displaying files"},
/* 549 */  {145, 'L', 60, PCB_ANSIYELLOW , "(@TIMELEFT@ min left), (H)elp, (V)iew, (F)lag, More"},
/* 550 */  {150, 'L', 72, PCB_ANSIGREEN  , "(A)bort, (E)dit, (G)oodbye, (L)ist, (P)rotocol, (Enter)=continue"},
/* 551 */  {145, 'L', 70, PCB_ANSIGREEN  , "(A)dd a File, (R)emove a File, (L)ist Batch, (Enter)=continue"},
/* 552 */  {145, 'L', 70, PCB_ANSIRED    , "(@OPTEXT@), Remove file number(s)"},
/* 553 */  {145, 'L', 70, PCB_ANSIWHITE  , "Removed from Batch: @OPTEXT@"},
/* 554 */  {145, 'L', 70, PCB_ANSIRED    , "(@OPTEXT@) duplicates a file already in the batch!"},
/* 555 */  {145, 'L', 70, PCB_ANSIRED    , "Batch limit reached.  @OPTEXT@ was not added to the batch."},
/* 556 */  {145, 'L', 70, PCB_ANSIYELLOW , "Clear the screen between each message"},
/* 557 */  {145, 'L', 70, PCB_ANSIYELLOW , "Enter the filename to flag for download (Enter)=none"},
/* 558 */  {145, 'L', 70, PCB_ANSIWHITE  , "       User Name                  Location              Last On"},
/* 559 */  {145, 'L', 70, PCB_ANSIYELLOW , "Enter text to scan for (ENTER alone finds all registered users)"},
/* 560 */  {145, 'L', 19, PCB_NOCHANGE   , "LOCAL Statistics"},
/* 561 */  {145, 'L', 70, PCB_ANSIRED    , "Delete this record"},
/* 562 */  {145, 'L', 70, PCB_ANSIYELLOW , "Enter Conference Numbers, (S)elect All, (D)eselect All or (Q)uit"},
/* 563 */  {145, 'L', 70, PCB_ANSIYELLOW , "Enter Conference Numbers or (Q)uit"},
/* 564 */  {152, 'L', 70, PCB_ANSIYELLOW , "Conf. Flags (R=Reg, X=Exp Reg, S=Scan, C=Conf Sysop, N=Net Status)"},
/* 565 */  {145, 'L', 70, PCB_ANSIGREEN  , "Selecting ALL Conferences, Please Wait"},
/* 566 */  {145, 'L', 70, PCB_ANSIGREEN  , "@FIRST@, you have new mail waiting in the following conference(s):"},
/* 567 */  {145, 'L', 70, PCB_ANSIYELLOW , "Read messages TO or FROM (enter user's name)"},
/* 568 */  {145, 'L', 70, PCB_ANSIRED    , "Both First and Last Names are required!"},
/* 569 */  {145, 'L', 70, PCB_ANSIYELLOW , "Copy Message to what Conference #"},
/* 570 */  {145, 'L', 56, PCB_NOCHANGE   , "Message Copied: #"},
/* 571 */  {145, 'L', 70, PCB_ANSIGREEN  , "Would you like to leave a comment to the Sysop instead"},
/* 572 */  {145, 'L', 10, PCB_ANSIGREEN  , " FREE"},
/* 573 */  {145, 'L', 15, PCB_ANSIGREEN  , " / NO TIME"},
/* 574 */  {145, 'L', 70, PCB_ANSIYELLOW , "Enter the filename to Test (Enter)=none"},
/* 575 */  {145, 'L', 25, PCB_ANSIGREEN  , "Verifying @OPTEXT@..."},
/* 576 */  {145, 'L', 40, PCB_ANSIWHITE  , " passed."},
/* 577 */  {145, 'L', 40, PCB_ANSIRED    , " FAILED!"},
/* 578 */  {145, 'L', 40, PCB_NOCHANGE   , "Verification FAILED on @OPTEXT@!"},
/* 579 */  {145, 'L', 23, PCB_ANSIYELLOW , "Paging the Sysop"},
/* 580 */  {152, 'L', 78, PCB_ANSIGREEN  , "Conference                                                          To   Total"},
/* 581 */  {152, 'L', 78, PCB_ANSIGREEN  , "  #   Name                                                          You  Found"},
/* 582 */  {152, 'L', 78, PCB_ANSIGREEN  , "----- ------------------------------------------------------------ ----- -----"},
/* 583 */  {145, 'L', 60, PCB_ANSIYELLOW , "Full Screen Editor Default: (Y)es, (N)o, (A)sk"},
/* 584 */  {145, 'L', 70, PCB_ANSIYELLOW , "(H)elp, (@OPTEXT@), Message Read Command"},
/* 585 */  {145, 'L', 70, PCB_ANSIYELLOW , "(H)elp, (1-@NUMDIR@), File List Command"},
/* 586 */  {152, 'L', 78, PCB_ANSIWHITE  , "Conference                                                   Last   High"},
/* 587 */  {152, 'L', 78, PCB_ANSIWHITE  , "  #   Name                                                   Read   Num. Flags"},
/* 588 */  {145, 'L', 56, PCB_ANSIWHITE  , "CTTY mode is now on, @FIRST@ ..."},
/* 589 */  {145, 'L', 56, PCB_ANSIWHITE  , "ANSI mode is now on, @FIRST@ ..."},
/* 590 */  {145, 'L', 30, PCB_NOCHANGE   , "Modem: @OPTEXT@"},
/* 591 */  {145, 'L', 30, PCB_NOCHANGE   , "Caller Number: @OPTEXT@"},
/* 592 */  {145, 'L', 30, PCB_NOCHANGE   , "Caller Security: @OPTEXT@"},
/* 593 */  {145, 'L', 20, PCB_NOCHANGE   , "of"},
/* 594 */  {145, 'L', 70, PCB_ANSIWHITE  , "Loading @OPTEXT@, please wait..."},
/* 595 */  {145, 'L', 40, PCB_ANSIYELLOW , "Did you forget your password?"},
/* 596 */  {145, 'L', 70, PCB_ANSIWHITE  , "Would you like to leave a comment to the sysop before logging off"},
/* 597 */  {145, 'L', 25, PCB_NOCHANGE   , "COMMENT: PASSWORD FAILURE"},
/* 598 */  {145, 'L', 40, PCB_ANSIYELLOW , "Is this correct"},
/* 599 */  {145, 'L', 77, PCB_ANSIWHITE  , "Please try using a different name.  If desired, try adding a middle initial."},
/* 600 */  {145, 'L', 40, PCB_ANSIRED    , "Lock caller out and disconnect"},
/* 601 */  {145, 'L', 40, PCB_ANSIRED    , "Disconnect caller"},
/* 602 */  {145, 'L', 40, PCB_ANSIRED    , "Give caller sysop privileges"},
/* 603 */  {145, 'L', 70, PCB_ANSIRED    , "Warning:  You have files flagged for download!"},
/* 604 */  {145, 'L', 40, PCB_ANSIWHITE  , "Proceed with running the @OPTEXT@ door"},
/* 605 */  {145, 'L', 40, PCB_ANSIWHITE  , "Proceed with logoff"},
/* 606 */  {145, 'L', 40, PCB_ANSIRED    , "@INCONF@has been selected."},
/* 607 */  {145, 'L', 40, PCB_ANSIRED    , "@INCONF@has been deselected."},
/* 608 */  {145, 'L', 40, PCB_ANSICYAN   , "Searching for @OPTEXT@"},
/* 609 */  {145, 'L', 60, PCB_ANSIGREEN  , "Upload Credits: 0.0 minutes, 0 bytes"},
/* 610 */  {145, 'L', 70, PCB_ANSIRED    , "Could not find @X07@OPTEXT@ @X0Cin the user file."},
/* 611 */  {145, 'L', 70, PCB_ANSIYELLOW , "(H)elp, (1-@NUMBLT@), Bulletin List Command"},
/* 612 */  {145, 'L', 70, PCB_ANSIGREEN  , "(@TIMELEFT@ min left), (H)elp, End of Message Command"},
/* 613 */  {145, 'L', 70, PCB_ANSIYELLOW , "(H)elp, (@OPTEXT@), Message Scan Command"},
/* 614 */  {145, 'L', 60, PCB_ANSIRED    , "(maximum per-conference limit reached)"},
/* 615 */  {145, 'L', 60, PCB_ANSIRED    , "(maximum message limit reached)"},
/* 616 */  {150, 'L', 77, PCB_ANSIRED    , "(Rcvd Files: @RFILES@  Bytes: @RBYTES@  CPS: @RCPS@  Combined CPS: @BICPS@)"},
/* 617 */  {150, 'L', 72, PCB_ANSIRED    , "Batch Upld: @RFILES@  Bytes: @RBYTES@  Avg. CPS: @RCPS@ (@BICPS@)"},
/* 618 */  {150, 'L', 72, PCB_ANSIRED    , "Batch Upld: @RFILES@  Bytes: @RBYTES@  Avg. CPS: @RCPS@"},
/* 619 */  {150, 'L', 72, PCB_ANSIRED    , "Batch Dnld: @SFILES@  Bytes: @SBYTES@  Avg. CPS: @SCPS@"},
/* 620 */  {150, 'L', 60, PCB_ANSIRED    , "~~(Files: @SFILES@  Bytes: @SBYTES@  Avg. CPS: @SCPS@)"},
/* 621 */  {150, 'L', 60, PCB_ANSIRED    , "~~(Files: @RFILES@  Bytes: @RBYTES@  Avg. CPS: @RCPS@)"},
/* 622 */  {150, 'L', 60, PCB_ANSIRED    , "~~(Avg. CPS: @SCPS@)"},
/* 623 */  {150, 'L', 60, PCB_ANSIRED    , "~~(Avg. CPS: @RCPS@)"},
/* 624 */  {150, 'L', 72, PCB_ANSIGREEN  , "Additional Commands: (@X0FFLAG@X0A) for download, (@X0FV@X0A)iew file."},
/* 625 */  {150, 'L', 30, PCB_ANSIRED    , "Size: @X07@OPTEXT@"},
/* 626 */  {150, 'L', 60, PCB_ANSIRED    , "That handle is not allowed, please pick another!"},
/* 627 */  {150, 'L', 60, PCB_ANSIYELLOW , "Scroll multi-screen messages"},
/* 628 */  {150, 'L', 60, PCB_ANSIYELLOW , "Use long headers when reading messages"},
/* 629 */  {150, 'L', 76, PCB_ANSIGREEN  , "(I)nsert, (L)ist Msg, (Q)uote, (S)ave, (SA)Save Attach, (U)pload Msg"},
/* 630 */  {150, 'L', 30, PCB_ANSIGREEN  , "Request Return Receipt"},
/* 631 */  {150, 'L', 30, PCB_ANSIRED    , "Return Receipt Requested.~~"},
/* 632 */  {150, 'L', 60, PCB_ANSIWHITE  , "Generating Receipt, please wait..."},
/* 633 */  {150, 'L', 30, PCB_ANSIRED    , "Your message number   : @X07"},
/* 634 */  {150, 'L', 30, PCB_ANSIRED    , "Which was addressed to: @X07"},
/* 635 */  {150, 'L', 30, PCB_ANSIRED    , "Was received/read on  : @X07"},
/* 636 */  {150, 'L', 30, PCB_ANSIGREEN  , "Route message to"},
/* 637 */  {150, 'L', 60, PCB_ANSIYELLOW , "Set editor workspace default to 79 columns"},
/* 638 */  {150, 'L', 60, PCB_ANSIRED    , "This conference is READ-ONLY!"},
/* 639 */  {150, 'L', 60, PCB_ANSIRED    , "Private messages are not allowed in this conference."},
/* 640 */  {150, 'L', 60, PCB_ANSIYELLOW , "Conference Password"},
/* 641 */  {150, 'L', 60, PCB_ANSIRED    , "The message already contains a File Attachment!"},
/* 642 */  {150, 'L', 30, PCB_ANSIYELLOW , "Carbon List To (Enter)=none"},
/* 643 */  {150, 'L', 30, PCB_ANSIRED    , "cc: @OPTEXT@"},
/* 644 */  {150, 'L', 50, PCB_ANSIYELLOW , "Read messages TO (enter user's name)"},
/* 645 */  {150, 'L', 50, PCB_ANSIYELLOW , "Read messages FROM (enter user's name)"},
/* 646 */  {150, 'L', 70, PCB_ANSIRED    , "The File Attachment is missing from disk and cannot be flagged."},
/* 647 */  {150, 'L', 70, PCB_ANSIRED    , "File Attachments are not allowed in this conference."},
/* 648 */  {150, 'L', 70, PCB_ANSIRED    , "Carbon Copy List maximum reached!"},
/* 649 */  {150, 'L', 70, PCB_ANSIRED    , "Errors encountered, PPE aborted..."},
/* 650 */  {150, 'L', 70, PCB_ANSIRED    , "Unable to allocate memory (@OPTEXT@)."},
/* 651 */  {150, 'L', 70, PCB_ANSIRED    , "Invalid token encountered (@OPTEXT@)."},
/* 652 */  {150, 'L', 70, PCB_ANSIRED    , "Error occurred executing PPE (@OPTEXT@)."},
/* 653 */  {150, 'L', 70, PCB_ANSIRED    , "An error occurred evaluating an expression."},
/* 654 */  {150, 'L', 70, PCB_ANSIRED    , "Error loading PPE (@OPTEXT@) from disk."},
/* 655 */  {150, 'L', 70, PCB_ANSIRED    , "Error appending (@OPTEXT@) to answer file."},
/* 656 */  {150, 'L', 70, PCB_ANSIRED    , "Error deleting file (@OPTEXT@)."},
/* 657 */  {150, 'L', 70, PCB_ANSIRED    , "Updating index file, please wait..."},
/* 658 */  {150, 'L', 60, PCB_ANSIGREEN  , "(72 chars/line, @OPTEXT@ lines maximum)"},
/* 659 */  {150, 'L', 60, PCB_ANSIGREEN  , "(79 chars/line, @OPTEXT@ lines maximum)"},
/* 660 */  {150, 'L', 60, PCB_ANSIGREEN  , "(45 chars/line, @OPTEXT@ lines maximum)"},
/* 661 */  {150, 'L', 25, PCB_NOCHANGE   , "(Carbon List)"},
/* 662 */  {150, 'L', 70, PCB_ANSIWHITE  , "Read your personal mail now: (Y)es, (N)o, (A)ll new mail"},
/* 663 */  {150, 'L', 70, PCB_ANSIGREEN  , "Scanning for new mail..."},
/* 664 */  {150, 'L', 70, PCB_ANSIWHITE  , "You have new mail waiting.  Please read it NOW."},
/* 665 */  {150, 'L', 70, PCB_ANSIGREEN  , "Scanning for new bulletins..."},
/* 666 */  {150, 'L', 70, PCB_ANSIGREEN  , "Your current Download:Upload file ratio is  : @X0F@FILERATIO@"},
/* 667 */  {150, 'L', 70, PCB_ANSIGREEN  , "Your current Download:Upload byte ratio is  : @X0F@BYTERATIO@"},
/* 668 */  {150, 'L', 70, PCB_ANSIGREEN  , "Your Download:Upload ratio must remain below: @X0F@OPTEXT@"},
/* 669 */  {150, 'L', 70, PCB_ANSIRED    , "Downloading @OPTEXT@ would exceed your file ratio."},
/* 670 */  {150, 'L', 70, PCB_ANSIRED    , "Downloading @OPTEXT@ would exceed your byte ratio."},
/* 671 */  {150, 'L', 70, PCB_ANSIGREEN  , "Number of files downloaded so far: @X0F@DLFILES@"},
/* 672 */  {150, 'L', 70, PCB_ANSIGREEN  , "Number of bytes downloaded so far: @X0F@DLBYTES@"},
/* 673 */  {150, 'L', 70, PCB_ANSIRED    , "Your download limit is set at    : @X0F@OPTEXT@"},
/* 674 */  {150, 'L', 70, PCB_ANSIRED    , "Downloading @OPTEXT@ would exceed your file limit."},
/* 675 */  {150, 'L', 70, PCB_ANSIRED    , "Downloading @OPTEXT@ would exceed your byte limit."},
/* 676 */  {150, 'L', 70, PCB_ANSIWHITE  , "Creating QWK Packet, please wait..."},
/* 677 */  {150, 'L', 70, PCB_ANSIRED    , "Error compressing file."},
/* 678 */  {150, 'L', 70, PCB_ANSIGREEN  , "QWK Commands: (D)ownload, (U)pload"},
/* 679 */  {150, 'L', 70, PCB_ANSIYELLOW , "Extracting messages, please wait..."},
/* 680 */  {150, 'L', 70, PCB_ANSIRED    , "Error extracting messages."},
/* 681 */  {150, 'L', 70, PCB_ANSIRED    , "Invalid menu option type encountered (@OPTEXT@)"},
/* 682 */  {150, 'L', 70, PCB_ANSIYELLOW , "@OPTEXT@ Menu Command ('MENU' for options)"},
/* 683 */  {150, 'L', 23, PCB_ANSICYAN   , "Running Event"},
/* 684 */  {150, 'L', 49, PCB_NOCHANGE   , "Event finished at~"},
/* 685 */  {150, 'L', 70, PCB_ANSIWHITE  , "Message(s) successfully inserted."},
/* 686 */  {150, 'L', 70, PCB_ANSIRED    , "Message insertion failed."},
/* 687 */  {150, 'L', 70, PCB_ANSIRED    , "Files matching (@OPTEXT@) are not allowed on this system."},
/* 688 */  {150, 'L', 60, PCB_ANSIYELLOW , "Date when message should be Packed-Out (mmddyy)"},
/* 689 */  {150, 'L', 60, PCB_ANSIRED    , "Message Pack Date: @OPTEXT@"},
/* 690 */  {150, 'L', 40, PCB_ANSIYELLOW , "Alias Name (enter=no change)"},
/* 691 */  {150, 'L', 60, PCB_ANSIWHITE  , "Hiding identity change, please wait..."},
/* 692 */  {150, 'L', 60, PCB_ANSIRED    , "Changed name to @OPTEXT@."},
/* 693 */  {150, 'L', 72, PCB_ANSIRED    , "Your true identity is protected while you remain in this conference."},
/* 694 */  {150, 'L', 60, PCB_NOCHANGE   , "Changed alias to @OPTEXT@."},
/* 695 */  {150, 'L', 60, PCB_NOCHANGE   , "Attempted to use @OPTEXT@ as an alias."},
/* 696 */  {150, 'L', 30, PCB_NOCHANGE   , "Byte Ratio :~"},
/* 697 */  {150, 'L', 30, PCB_NOCHANGE   , "File Ratio :~"},
/* 698 */  {150, 'L', 70, PCB_ANSIRED    , "Please enter your Address (2 lines provided for Street Address):"},
/* 699 */  {150, 'L', 50, PCB_ANSIYELLOW , "     Street (1 of 2)"},
/* 700 */  {150, 'L', 50, PCB_ANSIYELLOW , "     Street (2 of 2)"},
/* 701 */  {150, 'L', 50, PCB_ANSIYELLOW , "                City"},
/* 702 */  {150, 'L', 50, PCB_ANSIYELLOW , "               State"},
/* 703 */  {150, 'L', 50, PCB_ANSIYELLOW , "            Zip Code"},
/* 704 */  {150, 'L', 50, PCB_ANSIYELLOW , "             Country"},
/* 705 */  {150, 'L', 70, PCB_ANSIRED    , "You have already used that password.  Please pick another one."},
/* 706 */  {150, 'L', 70, PCB_ANSIYELLOW , "Enter your mother's maiden name"},
/* 707 */  {150, 'L', 70, PCB_ANSIWHITE  , "For verification, enter your mother's maiden name"},
/* 708 */  {150, 'L', 70, PCB_ANSIRED    , "Password too short!  Must be @OPTEXT@ characters or longer, try again."},
/* 709 */  {150, 'L', 70, PCB_ANSIRED    , "Your password cannot be a subset of your name, try again."},
/* 710 */  {150, 'L', 70, PCB_ANSIRED    , "Your password has expired.  Please enter a new password now."},
/* 711 */  {150, 'L', 78, PCB_ANSIRED    , "Your password will expire in @OPTEXT@ days.  Use the (W) command to change it."},
/* 712 */  {150, 'L', 70, PCB_ANSIGREEN  , "Date as (mmddyy) to search from (Enter)="},
/* 713 */  {150, 'L', 30, PCB_NOCHANGE   , "Return Receipt:~"},
/* 714 */  {152, 'L', 70, PCB_ANSIRED    , "Forwarded From: @X07@OPTEXT@"},
/* 715 */  {152, 'L', 70, PCB_ANSIRED    , "Forwarded By  : @X07@OPTEXT@"},
/* 716 */  {152, 'L', 75, PCB_ANSIRED    , "Insufficient Credits!  Credits Needed @OPTEXT@, Credits Left @CREDLEFT@."},
/* 717 */  {152, 'L', 70, PCB_ANSIMAGENTA, "Credits Used: @CREDNOW:9R@"},
/* 718 */  {152, 'L', 70, PCB_ANSIMAGENTA, "Credits Left: @CREDLEFT:9R@"},
/* 719 */  {152, 'L', 70, PCB_ANSIRED    , "You have exceeded your credit limit!"},
/* 720 */  {152, 'L', 70, PCB_ANSIRED    , "Your security level has been changed to @SECURITY@."},
/* 721 */  {152, 'L', 30, PCB_NOCHANGE   , "~NO COST"},
/* 722 */  {152, 'L', 30, PCB_NOCHANGE   , "RETURN RECEIPT"},
/* 723 */  {152, 'L', 30, PCB_NOCHANGE   , "COMMENT"},
/* 724 */  {152, 'L', 70, PCB_ANSIRED    , "Error in FROM name: @OPTEXT@"},
/* 725 */  {152, 'L', 70, PCB_ANSIWHITE  , "~Msg#    Ref#    To              From            Subject"},
/* 726 */  {152, 'L', 40, PCB_NOCHANGE   , "FILE FAILED VERIFICATION CHECK"},
/* 727 */  {152, 'L', 30, PCB_NOCHANGE   , "Uploaded by: @OPTEXT@"},
/* 728 */  {152, 'L', 60, PCB_ANSIYELLOW , "(@FNUM@) Enter the filename to Download (Enter)=none"},
/* 729 */  {152, 'L', 60, PCB_ANSIYELLOW , "(@FNUM@) Enter the Filename to Upload (Enter)=none"},
/* 730 */  {152, 'L', 70, PCB_NOCHANGE   , "------------------------  ------------------------  ---------------"},
/* 731 */  {152, 'L', 15, PCB_ANSIMAGENTA, "(Net)~"},
/* 732 */  {152, 'L', 65, PCB_ANSIYELLOW , "Set Message Capture Limit (System Max=@OPTEXT@)"},
/* 733 */  {152, 'L', 65, PCB_ANSIYELLOW , "Set Per-Conference Message Capture Limit (System Max=@OPTEXT@)"},
/* 734 */  {152, 'L', 65, PCB_ANSIYELLOW , "Maximum Size to Auto-Include Personal Attachments in QWK Packet"},
/* 735 */  {152, 'L', 65, PCB_ANSIYELLOW , "Maximum Size to Auto-Include Attachments in QWK Packet"},
/* 736 */  {152, 'L', 30, PCB_ANSIGREEN  , "Post-to Groups"},
/* 737 */  {152, 'L', 30, PCB_ANSIGREEN  , "Follow-up Groups"},
/* 738 */  {152, 'L', 23, PCB_ANSICYAN   , "Handling Mail"},

/* 739 */  {153, 'L', 60, PCB_ANSIYELLOW , "(@TIMELEFT@ min left), (V)iew, (F)lag, (S)how, More"},
/* 740 */  {153, 'L', 40, PCB_ANSIYELLOW , "Enter DIR Command"},
/* 741 */  {153, 'L', 40, PCB_ANSIRED    , "No files found."},
/* 742 */  {153, 'L', 65, PCB_ANSIMAGENTA, "Directory of @OPTEXT@"},
/* 743 */  {153, 'L', 75, PCB_ANSIWHITE  , "Short Description Mode in effect"},
/* 744 */  {153, 'L', 75, PCB_ANSIWHITE  , "Long Description Mode in effect"},
/* 745 */  {153, 'L', 60, PCB_ANSIYELLOW , "Show long description of what file"},
/* 746 */  {153, 'L', 60, PCB_ANSIYELLOW , "Set default file description to SHORT (one-line) format"},
};

/*TEXT_ARRAY in file MKPCBTXT.C should be changed
 to # of last string + 1. i.e.(561+1=562)*/

